"{ Package: 'stx:libsvn' }"

"{ NameSpace: SVN }"

Wizard subclass:#UpdateWizard
	instanceVariableNames:'revision'
	classVariableNames:''
	poolDictionaries:''
	category:'SVN-UI-Dialogs'
!

WizardPane subclass:#ChangeSetPane
	instanceVariableNames:'changeSetHolder finalChangeSetHolder'
	classVariableNames:''
	poolDictionaries:''
	privateIn:UpdateWizard
!

WizardPane subclass:#MergePane
	instanceVariableNames:'diffSetHolder changeSetHolder'
	classVariableNames:''
	poolDictionaries:''
	privateIn:UpdateWizard
!

WizardPane subclass:#RevisionPane
	instanceVariableNames:'logHolder revisionHolder'
	classVariableNames:''
	poolDictionaries:''
	privateIn:UpdateWizard
!


!UpdateWizard methodsFor:'accessing'!

defaultTitle
    "Superclass SVN::Dialog says that I am responsible to implement this method"
    
    ^self revision == Revision head 
        ifTrue:['Update']
        ifFalse:['Load revision...']

    "Created: / 03-10-2008 / 13:58:40 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 09-04-2009 / 08:41:35 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

firstPane
    "
     Answers the very first pane to show"

    ^self revision 
        ifNotNil:
            [MergePane new]
        ifNil:
            [RevisionPane new]

    "Modified: / 02-04-2009 / 16:34:13 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

revision
    revision ifNil:
        [revision := self task revision].
    ^revision

    "Modified: / 02-04-2009 / 16:33:55 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

revision:aRevision
    revision := aRevision.
! !

!UpdateWizard methodsFor:'actions'!

doAccept
    self showProgressWhile: 
            [ (self task)
                updateChangeSet: self pane value finalChangeSetHolder value;
                doApplyResolutions.
            self accept value: true ].

    "Created: / 02-04-2009 / 23:19:59 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 19-08-2009 / 14:26:59 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!UpdateWizard::ChangeSetPane class methodsFor:'interface specs'!

windowSpec
    "This resource specification was automatically generated
     by the UIPainter of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the UIPainter may not be able to read the specification."

    "
     UIPainter new openOnClass:SVN::UpdateWizard::ChangeSetPane andSelector:#windowSpec
     SVN::UpdateWizard::ChangeSetPane new openInterface:#windowSpec
     SVN::UpdateWizard::ChangeSetPane open
    "

    <resource: #canvas>

    ^ 
     #(FullSpec
        name: windowSpec
        window: 
       (WindowSpec
          label: 'UpdateChangeSet'
          name: 'UpdateChangeSet'
          min: (Point 10 10)
          bounds: (Rectangle 0 0 300 300)
        )
        component: 
       (SpecCollection
          collection: (
           (SubCanvasSpec
              name: 'HierarchicalChangeSet'
              layout: (LayoutFrame 0 0 0 0 0 1 0 1)
              hasHorizontalScrollBar: false
              hasVerticalScrollBar: false
              majorKey: #'Tools::HierarchicalChangesetDialog'
              subAspectHolders: 
             (Array
                
               (SubChannelInfoSpec
                  subAspect: changeSetHolder
                  aspect: changeSetHolder
                ) 
               (SubChannelInfoSpec
                  subAspect: selectedChangeSetHolder
                  aspect: finalChangeSetHolder
                )
              )
              createNewApplication: true
              createNewBuilder: true
            )
           )
         
        )
      )
! !

!UpdateWizard::ChangeSetPane methodsFor:'accessing'!

changeSet

    ^self changeSetHolder value

    "Created: / 02-04-2009 / 22:30:20 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

changeSet: aChangeSet

    ^self changeSetHolder value: aChangeSet

    "Created: / 02-04-2009 / 22:30:28 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!UpdateWizard::ChangeSetPane methodsFor:'actions'!

enter

    self changeSet isEmpty ifTrue:
        [self 
            showMessage:'Package already updated to revision ', self task revision printString;
            doAcceptEnabled: false;
            goPrevEnabled: false]

    "Created: / 09-04-2009 / 08:18:30 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!UpdateWizard::ChangeSetPane methodsFor:'aspects'!

changeSetHolder
    "return/create the 'changeSetHolder' value holder (automatically generated)"

    changeSetHolder isNil ifTrue:[
        changeSetHolder := ChangeSet new asValue
    ].
    ^ changeSetHolder

    "Modified: / 02-04-2009 / 18:06:02 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

changeSetHolder:aValueHolder
    "set the 'changeSetHolder' value holder (automatically generated)"

    changeSetHolder := aValueHolder.
!

finalChangeSetHolder
    "return/create the 'finalChangeSetHolder' value holder (automatically generated)"

    finalChangeSetHolder isNil ifTrue:[
        finalChangeSetHolder := ValueHolder new.
    ].
    ^ finalChangeSetHolder
!

finalChangeSetHolder:aValueHolder
    "set the 'finalChangeSetHolder' value holder (automatically generated)"

    finalChangeSetHolder := aValueHolder.
! !

!UpdateWizard::ChangeSetPane methodsFor:'queries'!

canDoAccept

    ^true

    "Created: / 02-04-2009 / 17:21:13 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

canGoNext

    ^false

    "Created: / 02-04-2009 / 17:21:13 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!UpdateWizard::MergePane class methodsFor:'interface specs'!

windowSpec
    "This resource specification was automatically generated
     by the UIPainter of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the UIPainter may not be able to read the specification."

    "
     UIPainter new openOnClass:SVN::UpdateWizard::MergePane andSelector:#windowSpec
     SVN::UpdateWizard::MergePane new openInterface:#windowSpec
     SVN::UpdateWizard::MergePane open
    "

    <resource: #canvas>

    ^ 
     #(FullSpec
        name: windowSpec
        window: 
       (WindowSpec
          label: 'Merge Pane'
          name: 'Merge Pane'
          min: (Point 10 10)
          bounds: (Rectangle 0 0 300 300)
        )
        component: 
       (SpecCollection
          collection: (
           (SubCanvasSpec
              name: 'Merge'
              layout: (LayoutFrame 0 0 0 0 0 1 0 1)
              hasHorizontalScrollBar: false
              hasVerticalScrollBar: false
              majorKey: #'Tools::SmalltalkMergeTool'
              subAspectHolders: 
             (Array
                
               (SubChannelInfoSpec
                  subAspect: changeSetHolder
                  aspect: changeSetHolder
                ) 
               (SubChannelInfoSpec
                  subAspect: diffSetHolder
                  aspect: diffSetHolder
                )
                
               (SubChannelInfoSpec
                  subAspect: inAOnlyLabelHolder
                  aspect: inAOnlyLabelHolder
                ) 
               (SubChannelInfoSpec
                  subAspect: inBOnlyLabelHolder
                  aspect: inBOnlyLabelHolder
                )
              )
              createNewApplication: true
              createNewBuilder: true
            )
           )
         
        )
      )

    "Modified: / 09-08-2009 / 14:15:54 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!UpdateWizard::MergePane methodsFor:'actions'!

enter
    self task mergeDiffSet ifNil: 
            [ self showProgressWhile: 
                    [ self task doUpdateWorkingCopy.
                    self task mergeDiffSet isEmpty 
                        ifTrue: [ self goNext ]
                        ifFalse: [ self diffSetHolder value: self task mergeDiffSet ] ] ].

    "Created: / 02-04-2009 / 17:14:38 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 08-04-2009 / 20:14:33 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

goNext

    self next changeSet:
        (self task loadChangeSet , self changeSetHolder value).
    super goNext.

    "Created: / 02-04-2009 / 22:32:47 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!UpdateWizard::MergePane methodsFor:'aspects'!

changeSetHolder
    "return/create the 'changeSetHolder' value holder (automatically generated)"

    changeSetHolder isNil ifTrue:[
        changeSetHolder := ChangeSet new asValue.
    ].
    ^ changeSetHolder

    "Modified: / 02-04-2009 / 22:29:00 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

changeSetHolder:aValueHolder
    "set the 'changeSetHolder' value holder (automatically generated)"

    changeSetHolder := aValueHolder.
!

diffSetHolder
    "return/create the 'diffSetHolder' value holder (automatically generated)"

    diffSetHolder isNil ifTrue:[
        diffSetHolder := ChangeSet::DiffSet new asValue
    ].
    ^ diffSetHolder

    "Modified: / 02-04-2009 / 16:42:05 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

diffSetHolder:aValueHolder
    "set the 'diffSetHolder' value holder (automatically generated)"

    diffSetHolder := aValueHolder.
!

inAOnlyLabelHolder

    ^'Only in Image'

    "Created: / 09-04-2009 / 09:20:18 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

inBOnlyLabelHolder

    ^'Only in r', self task revision printString

    "Created: / 09-04-2009 / 09:20:34 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!UpdateWizard::MergePane methodsFor:'private'!

createNext
    "Superclass SVN::Wizard::Pane says that I am responsible to implement this method"

    ^UpdateWizard::ChangeSetPane new

    "Modified: / 02-04-2009 / 22:32:08 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!UpdateWizard::RevisionPane class methodsFor:'interface specs'!

windowSpec
    "This resource specification was automatically generated
     by the UIPainter of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the UIPainter may not be able to read the specification."

    "
     UIPainter new openOnClass:SVN::UpdateWizard::RevisionPane andSelector:#windowSpec
     SVN::UpdateWizard::RevisionPane new openInterface:#windowSpec
     SVN::UpdateWizard::RevisionPane open
    "

    <resource: #canvas>

    ^ 
     #(FullSpec
        name: windowSpec
        window: 
       (WindowSpec
          label: 'RevisionPane'
          name: 'RevisionPane'
          bounds: (Rectangle 0 0 300 300)
        )
        component: 
       (SpecCollection
          collection: (
           (SubCanvasSpec
              name: 'RevisionSelectionBrowser'
              layout: (LayoutFrame 0 0 0 0 0 1 0 1)
              hasHorizontalScrollBar: false
              hasVerticalScrollBar: false
              majorKey: #'SVN::RevisionLogBrowser'
              subAspectHolders: 
             (Array
                
               (SubChannelInfoSpec
                  subAspect: model
                  aspect: logHolder
                ) 
               (SubChannelInfoSpec
                  subAspect: selectionHolder
                  aspect: revisionHolder
                )
              )
              createNewApplication: true
              createNewBuilder: true
            )
           )
         
        )
      )
! !

!UpdateWizard::RevisionPane methodsFor:'aspects'!

logHolder

    logHolder ifNil:
        [logHolder := nil asValue.
        self showProgressWhile:
            [logHolder value:self task branch log]].
    ^logHolder

    "Created: / 24-03-2009 / 14:58:27 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 24-03-2009 / 19:32:01 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

revisionHolder
    "return/create the 'revisionHolder' value holder (automatically generated)"

    revisionHolder isNil ifTrue:[
        revisionHolder := nil asValue.
        revisionHolder 
            onChangeSend: #updateButtons to: self;
            onChangeSend: #updateRevision to: self.
    ].
    ^ revisionHolder

    "Modified: / 09-04-2009 / 09:53:15 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!UpdateWizard::RevisionPane methodsFor:'change & update'!

updateRevision

    self task revision: self revisionHolder value revision

    "Created: / 09-04-2009 / 09:53:44 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!UpdateWizard::RevisionPane methodsFor:'private'!

createNext
    "Superclass SVN::Wizard::Pane says that I am responsible to implement this method"
    
    ^UpdateWizard::MergePane new

    "Modified: / 02-04-2009 / 17:05:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!UpdateWizard::RevisionPane methodsFor:'queries'!

canGoNext
    "Superclass SVN::Wizard::Pane says that I am responsible to implement this method"
    ^self revisionHolder value notNil

    "Modified: / 24-03-2009 / 19:27:31 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!UpdateWizard class methodsFor:'documentation'!

version
    ^ '$Header$'
!

version_CVS
    ^ '$Header$'
!

version_SVN
    ^'Id: SVN__UpdateWizard.st 110 2009-08-19 13:21:10Z vranyj1 '
! !
